-- author RivalBomb

claasC600 = {};

function claasC600.prerequisitesPresent(specializations)
    return true;
end;

function claasC600:load(xmlFile)
	self.bladeIndex = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.blade#index"));
	self.bladeIndex2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.blade#index2"));
	
	self.bladeDir = 1;
	self.bladePos=0;
	self.bladeSpeed = 0;
	self.bladeSpeedMax = 0.9;
	
	
	
	-- reel Fruits
	self.reelArmNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.reelFruitObjects#reelArmNode"));
	self.reelNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.reelFruitObjects#reelNode"));
	
	self.reelFruitObjects = {};
	self.reelFruitObjectsBarley = {};
	self.reelFruitObjectsBarleyStart = {};
	self.reelFruitObjectsWheat = {};
	self.reelFruitObjectsWheatStart = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.reelFruitObjects.reelFruitBarley(%d)", i);
		local index = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
		if index==nil then
			break;
		end;
		if index ~= nil then
			setVisibility(index, false);
		end;
		i = i +1;
		self.reelFruitObjectsBarley[i] = index;
		self.reelFruitObjectsBarleyStart[i] = 0;
	end;
	local j = 0;
	while true do
		local key = string.format("vehicle.reelFruitObjects.reelFruitWheat(%d)", j);
		local index = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
		if index==nil then
			break;
		end;
		if index ~= nil then
			setVisibility(index, false);
		end;
		j = j +1;
		self.reelFruitObjectsWheat[j] = index;
		self.reelFruitObjectsWheatStart[j] = 0;
	end;
	
	self.reelFruitObjects.curNode = math.random(1, 9);
	
	self.reelFruitObjects.timer = 0;
	self.reelFruitObjects.minTime = 200;
	self.reelFruitObjects.maxTime = 1500;
	self.reelFruitObjects.curTime = math.random(self.reelFruitObjects.minTime, self.reelFruitObjects.maxTime);
end;
function claasC600:delete()
end;
function claasC600:mouseEvent(posX, posY, isDown, isUp, button)
end;
function claasC600:keyEvent(unicode, sym, modifier, isDown)
end;
function claasC600:update(dt)
	if self:getIsActive() then
		self.bladePos=self.bladePos+(0.05*self.bladeDir*self.bladeSpeed);
		if self.bladePos >= 0.1 then
			self.bladeDir=-1;
		elseif self.bladePos <= -0.1 then
			self.bladeDir=1;
		end;
		if self.reelStarted then
			self.bladeSpeed = math.min(self.bladeSpeed+0.005, self.bladeSpeedMax);
		else
			self.bladeSpeed = math.max(self.bladeSpeed-0.005, 0);
		end;
		if self.bladeIndex ~= nil then
			setTranslation(self.bladeIndex, self.bladePos,0,0);
		end;
		if self.bladeIndex2 ~= nil then
			setTranslation(self.bladeIndex2, self.bladePos,0,0);
		end;
		
		
		-- reel Fruits
		local rotX,_,_ = getRotation(self.reelArmNode);
		if (self.reelFruitObjectsWheat[1] ~= nil and self.reelFruitObjectsWheat[2] ~= nil and self.reelFruitObjectsWheat[3] ~= nil and self.reelFruitObjectsWheat[4] ~= nil and self.reelFruitObjectsWheat[5] ~= nil and self.reelFruitObjectsWheat[6] ~= nil and self.reelFruitObjectsWheat[7] ~= nil and self.reelFruitObjectsWheat[8] ~= nil and self.reelFruitObjectsWheat[9] ~= nil) and (self.reelFruitObjectsBarley[1] ~= nil and self.reelFruitObjectsBarley[2] ~= nil and self.reelFruitObjectsBarley[3] ~= nil and self.reelFruitObjectsBarley[4] ~= nil and self.reelFruitObjectsBarley[5] ~= nil and self.reelFruitObjectsBarley[6] ~= nil and self.reelFruitObjectsBarley[7] ~= nil and self.reelFruitObjectsBarley[8] ~= nil and self.reelFruitObjectsBarley[9] ~= nil) then
			if rotX < math.rad(10) and self.reelStarted and self.lastCutterAreaBiggerZero then
				if self.currentInputFruitType == FruitUtil.FRUITTYPE_BARLEY then
					self.reelFruitObjects.timer=self.reelFruitObjects.timer+dt;
					if self.reelFruitObjects.timer >= self.reelFruitObjects.curTime then
						self.reelFruitObjects.timer = 0;
						self.reelFruitObjects.curTime = math.random(self.reelFruitObjects.minTime, self.reelFruitObjects.maxTime);
						
						self.reelFruitObjects.curNode = math.random(1, 9);
						self.reelFruitObjectsBarleyStart[self.reelFruitObjects.curNode],_,_ = getRotation(self.reelNode);
						setVisibility(self.reelFruitObjectsBarley[self.reelFruitObjects.curNode], true);
					end;
				elseif self.currentInputFruitType == FruitUtil.FRUITTYPE_WHEAT then
					self.reelFruitObjects.timer=self.reelFruitObjects.timer+dt;
					if self.reelFruitObjects.timer >= self.reelFruitObjects.curTime then
						self.reelFruitObjects.timer = 0;
						self.reelFruitObjects.curTime = math.random(self.reelFruitObjects.minTime, self.reelFruitObjects.maxTime);
						
						self.reelFruitObjects.curNode = math.random(1, 9);
						self.reelFruitObjectsWheatStart[self.reelFruitObjects.curNode],_,_ = getRotation(self.reelNode);
						setVisibility(self.reelFruitObjectsWheat[self.reelFruitObjects.curNode], true);
					end;
				else
					setVisibility(self.reelFruitObjectsWheat[1], false);
					setVisibility(self.reelFruitObjectsWheat[2], false);
					setVisibility(self.reelFruitObjectsWheat[3], false);
					setVisibility(self.reelFruitObjectsWheat[4], false);
					setVisibility(self.reelFruitObjectsWheat[5], false);
					setVisibility(self.reelFruitObjectsWheat[6], false);
					setVisibility(self.reelFruitObjectsWheat[7], false);
					setVisibility(self.reelFruitObjectsWheat[8], false);
					setVisibility(self.reelFruitObjectsWheat[9], false);
					
					setVisibility(self.reelFruitObjectsBarley[1], false);
					setVisibility(self.reelFruitObjectsBarley[2], false);
					setVisibility(self.reelFruitObjectsBarley[3], false);
					setVisibility(self.reelFruitObjectsBarley[4], false);
					setVisibility(self.reelFruitObjectsBarley[5], false);
					setVisibility(self.reelFruitObjectsBarley[6], false);
					setVisibility(self.reelFruitObjectsBarley[7], false);
					setVisibility(self.reelFruitObjectsBarley[8], false);
					setVisibility(self.reelFruitObjectsBarley[9], false);
					
				end;
			end;
			local curReelRot,_,_ = getRotation(self.reelNode);
			if getVisibility(self.reelFruitObjectsWheat[1]) and curReelRot <= self.reelFruitObjectsWheatStart[1]-5 then
				setVisibility(self.reelFruitObjectsWheat[1], false);
			elseif getVisibility(self.reelFruitObjectsWheat[2]) and curReelRot <= self.reelFruitObjectsWheatStart[2]-5 then
				setVisibility(self.reelFruitObjectsWheat[2], false);
			elseif getVisibility(self.reelFruitObjectsWheat[3]) and curReelRot <= self.reelFruitObjectsWheatStart[3]-5 then
				setVisibility(self.reelFruitObjectsWheat[3], false);
			elseif getVisibility(self.reelFruitObjectsWheat[4]) and curReelRot <= self.reelFruitObjectsWheatStart[4]-5 then
				setVisibility(self.reelFruitObjectsWheat[4], false);
			elseif getVisibility(self.reelFruitObjectsWheat[5]) and curReelRot <= self.reelFruitObjectsWheatStart[5]-5 then
				setVisibility(self.reelFruitObjectsWheat[5], false);
			elseif getVisibility(self.reelFruitObjectsWheat[6]) and curReelRot <= self.reelFruitObjectsWheatStart[6]-5 then
				setVisibility(self.reelFruitObjectsWheat[6], false);
			elseif getVisibility(self.reelFruitObjectsWheat[7]) and curReelRot <= self.reelFruitObjectsWheatStart[7]-5 then
				setVisibility(self.reelFruitObjectsWheat[7], false);
			elseif getVisibility(self.reelFruitObjectsWheat[8]) and curReelRot <= self.reelFruitObjectsWheatStart[8]-5 then
				setVisibility(self.reelFruitObjectsWheat[8], false);
			elseif getVisibility(self.reelFruitObjectsWheat[9]) and curReelRot <= self.reelFruitObjectsWheatStart[9]-5 then
				setVisibility(self.reelFruitObjectsWheat[9], false);
			end;
			if getVisibility(self.reelFruitObjectsBarley[1]) and curReelRot <= self.reelFruitObjectsBarleyStart[1]-5 then
				setVisibility(self.reelFruitObjectsBarley[1], false);
			elseif getVisibility(self.reelFruitObjectsBarley[2]) and curReelRot <= self.reelFruitObjectsBarleyStart[2]-5 then
				setVisibility(self.reelFruitObjectsBarley[2], false);
			elseif getVisibility(self.reelFruitObjectsBarley[3]) and curReelRot <= self.reelFruitObjectsBarleyStart[3]-5 then
				setVisibility(self.reelFruitObjectsBarley[3], false);
			elseif getVisibility(self.reelFruitObjectsBarley[4]) and curReelRot <= self.reelFruitObjectsBarleyStart[4]-5 then
				setVisibility(self.reelFruitObjectsBarley[4], false);
			elseif getVisibility(self.reelFruitObjectsBarley[5]) and curReelRot <= self.reelFruitObjectsBarleyStart[5]-5 then
				setVisibility(self.reelFruitObjectsBarley[5], false);
			elseif getVisibility(self.reelFruitObjectsBarley[6]) and curReelRot <= self.reelFruitObjectsBarleyStart[6]-5 then
				setVisibility(self.reelFruitObjectsBarley[6], false);
			elseif getVisibility(self.reelFruitObjectsBarley[7]) and curReelRot <= self.reelFruitObjectsBarleyStart[7]-5 then
				setVisibility(self.reelFruitObjectsBarley[7], false);
			elseif getVisibility(self.reelFruitObjectsBarley[8]) and curReelRot <= self.reelFruitObjectsBarleyStart[8]-5 then
				setVisibility(self.reelFruitObjectsBarley[8], false);
			elseif getVisibility(self.reelFruitObjectsBarley[9]) and curReelRot <= self.reelFruitObjectsBarleyStart[9]-5 then
				setVisibility(self.reelFruitObjectsBarley[9], false);
			end;
		end;
	end;
end;
function claasC600:updateTick(dt)
end;
function claasC600:draw()
end;